Index: trunk/src/main/java/omq/common/util/Serializer.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializer.java	(revision 62)
+++ trunk/src/main/java/omq/common/util/Serializer.java	(revision 72)
@@ -4,5 +4,4 @@
 import java.util.Properties;
 
-import omq.common.event.Event;
 import omq.common.message.Request;
 import omq.common.message.Response;
@@ -48,9 +47,9 @@
 			try {
 				String className = env.getProperty(ParameterQueue.SERIALIZER_NAME, Serializer.JAVA);
-				
+
 				if (className == null || className.isEmpty()) {
 					throw new ClassNotFoundException("Class name is null or empty.");
 				}
-				
+
 				serializer = getInstance(className);
 			} catch (Exception ex) {
@@ -62,5 +61,5 @@
 	}
 
-	public ISerializer getInstance(String type) throws SerializerException {				
+	public ISerializer getInstance(String type) throws SerializerException {
 		if (KRYO.equals(type)) {
 			if (kryoSerializer == null) {
@@ -79,5 +78,5 @@
 			return javaSerializer;
 		}
-		
+
 		throw new SerializerException("Serializer not found.");
 	}
@@ -148,26 +147,3 @@
 	}
 
-	public Event deserializeEvent(byte[] bytes) throws SerializerException {
-		ISerializer instance = getInstance();
-
-		Boolean enableCompression = getEnableCompression();
-		if (enableCompression) {
-			try {
-				byte[] unZippedBytes = Zipper.unzip(bytes);
-				return instance.deserializeEvent(unZippedBytes);
-			} catch (IOException e) {
-				throw new SerializerException(e.getMessage(), e);
-			}
-		} else {
-			return instance.deserializeEvent(bytes);
-		}
-	}
-
-	// public static void removeSerializers() {
-	// logger.warn("Removing serializers");
-	// serializer = null;
-	// kryoSerializer = null;
-	// javaSerializer = null;
-	// gsonSerializer = null;
-	// }
 }
Index: trunk/src/main/java/omq/common/util/Serializers/GsonImp.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/GsonImp.java	(revision 62)
+++ trunk/src/main/java/omq/common/util/Serializers/GsonImp.java	(revision 72)
@@ -3,5 +3,4 @@
 import java.util.List;
 
-import omq.common.event.Event;
 import omq.common.message.Request;
 import omq.common.message.Response;
@@ -75,24 +74,3 @@
 	}
 
-	@Override
-	public Event deserializeEvent(byte[] bytes) throws SerializerException {
-		try {
-			String json = new String(bytes);
-
-			JsonParser parser = new JsonParser();
-			JsonObject jsonObj = parser.parse(json).getAsJsonObject();
-
-			String type = jsonObj.get("type").getAsString();
-
-			JsonElement jsonElement = jsonObj.get("event");
-			Event event;
-
-			event = (Event) gson.fromJson(jsonElement, Class.forName(type));
-
-			return event;
-		} catch (Exception e) {
-			throw new SerializerException("Deserialize event", e.getCause());
-		}
-	}
-
 }
Index: trunk/src/main/java/omq/common/util/Serializers/ISerializer.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/ISerializer.java	(revision 62)
+++ trunk/src/main/java/omq/common/util/Serializers/ISerializer.java	(revision 72)
@@ -1,5 +1,4 @@
 package omq.common.util.Serializers;
 
-import omq.common.event.Event;
 import omq.common.message.Request;
 import omq.common.message.Response;
@@ -18,5 +17,3 @@
 
 	public Response deserializeResponse(byte[] bytes, Class<?> type) throws SerializerException;
-
-	public Event deserializeEvent(byte[] bytes) throws SerializerException;
 }
Index: trunk/src/main/java/omq/common/util/Serializers/JavaImp.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/JavaImp.java	(revision 62)
+++ trunk/src/main/java/omq/common/util/Serializers/JavaImp.java	(revision 72)
@@ -6,6 +6,4 @@
 import java.io.ObjectOutputStream;
 
-import omq.common.event.Event;
-import omq.common.event.EventWrapper;
 import omq.common.message.Request;
 import omq.common.message.Response;
@@ -51,10 +49,4 @@
 	}
 
-	@Override
-	public Event deserializeEvent(byte[] bytes) throws SerializerException {
-		EventWrapper wrapper = (EventWrapper) deserializeObject(bytes);
-		return wrapper.getEvent();
-	}
-
 	public Object deserializeObject(byte[] bytes) throws SerializerException {
 		try {
Index: trunk/src/main/java/omq/common/util/Serializers/KryoImp.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/KryoImp.java	(revision 62)
+++ trunk/src/main/java/omq/common/util/Serializers/KryoImp.java	(revision 72)
@@ -3,14 +3,12 @@
 import java.io.ByteArrayOutputStream;
 
-import com.esotericsoftware.kryo.Kryo;
-import com.esotericsoftware.kryo.io.Input;
-import com.esotericsoftware.kryo.io.Output;
-
-import omq.common.event.Event;
-import omq.common.event.EventWrapper;
 import omq.common.message.Request;
 import omq.common.message.Response;
 import omq.exception.SerializerException;
 import omq.server.RemoteObject;
+
+import com.esotericsoftware.kryo.Kryo;
+import com.esotericsoftware.kryo.io.Input;
+import com.esotericsoftware.kryo.io.Output;
 
 /**
@@ -53,10 +51,4 @@
 	}
 
-	@Override
-	public Event deserializeEvent(byte[] bytes) throws SerializerException {
-		EventWrapper wrapper = (EventWrapper) deserializeObject(bytes, EventWrapper.class);
-		return wrapper.getEvent();
-	}
-
 	public Object deserializeObject(byte[] bytes, Class<?> type) throws SerializerException {
 		try {