Index: trunk/src/main/java/omq/common/util/OmqConnectionFactory.java
===================================================================
--- trunk/src/main/java/omq/common/util/OmqConnectionFactory.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/OmqConnectionFactory.java	(revision 83)
@@ -13,4 +13,5 @@
 
 /**
+ * This class creates RabbitMQ connections
  * 
  * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
@@ -23,4 +24,14 @@
 	private static int connectionTimeout = 2 * 1000;
 
+	/**
+	 * If this class is wanted to use as a singleton class this is the init
+	 * function
+	 * 
+	 * @param env
+	 *            - environment that sets the properties needed by RabbitMQ
+	 * @throws KeyManagementException
+	 * @throws NoSuchAlgorithmException
+	 * @throws IOException
+	 */
 	public static void init(Properties env) throws KeyManagementException, NoSuchAlgorithmException, IOException {
 		if (connection == null) {
@@ -29,4 +40,12 @@
 	}
 
+	/**
+	 * This function returns a working connection.
+	 * 
+	 * @param env
+	 *            - used if it's necessary to create a new connection
+	 * @return workingConnection
+	 * @throws Exception
+	 */
 	public static Connection getNewWorkingConnection(Properties env) throws Exception {
 		Connection connection = null;
@@ -50,4 +69,16 @@
 	}
 
+	/**
+	 * This function creates a new rabbitmq connection using the properties set
+	 * in env
+	 * 
+	 * @param env
+	 *            - Properties needed to create a new connection: username,
+	 *            password, rabbit_host, rabbit_port, enable_ssl (optional)
+	 * @return new Connection
+	 * @throws IOException
+	 * @throws KeyManagementException
+	 * @throws NoSuchAlgorithmException
+	 */
 	public static Connection getNewConnection(Properties env) throws IOException, KeyManagementException, NoSuchAlgorithmException {
 		// Get login info of rabbitmq
@@ -59,5 +90,5 @@
 		int port = Integer.parseInt(env.getProperty(ParameterQueue.RABBIT_PORT));
 
-		boolean ssl = Boolean.parseBoolean(env.getProperty(ParameterQueue.ENABLE_SSL));
+		boolean ssl = Boolean.parseBoolean(env.getProperty(ParameterQueue.ENABLE_SSL, "false"));
 
 		// Start a new connection and channel
@@ -78,4 +109,10 @@
 	}
 
+	/**
+	 * This method creates a new channel if the singleton pattern is used
+	 * 
+	 * @return new Channel
+	 * @throws IOException
+	 */
 	public static Channel getNewChannel() throws IOException {
 		Channel channel = connection.createChannel();
Index: trunk/src/main/java/omq/common/util/ParameterQueue.java
===================================================================
--- trunk/src/main/java/omq/common/util/ParameterQueue.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/ParameterQueue.java	(revision 83)
@@ -2,4 +2,5 @@
 
 /**
+ * This class is used to create new environments.
  * 
  * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
@@ -7,8 +8,4 @@
  */
 public class ParameterQueue {
-
-	/*
-	 * Properties environment
-	 */
 
 	/**
@@ -69,7 +66,4 @@
 	public static String MESSAGE_TTL_IN_QUEUES = "omq.message_ttl_queue";
 
-	// TODO persistent messages? the messages will be saved in the disk if this
-	// flag is set true
-
 	/**
 	 * Set if the system will use ssl
@@ -111,5 +105,5 @@
 
 	/**
-	 * Time in milis
+	 * Time in milis by default is set in a minute
 	 */
 	public static long DEFAULT_TIMEOUT = 1 * 1000 * 60;
Index: trunk/src/main/java/omq/common/util/Serializer.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializer.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/Serializer.java	(revision 83)
@@ -15,10 +15,12 @@
 /**
  * 
+ * Serializer enables to serialize the requests and the responses of the
+ * remoteObjects. This class is used to have the same serializer object a not to
+ * create new instances every time they are needed.
+ * 
  * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
  * 
  */
 public class Serializer {
-	// private static final Logger logger =
-	// Logger.getLogger(Serializer.class.getName());
 	public static final String KRYO = "kryo";
 	public static final String JAVA = "java";
Index: trunk/src/main/java/omq/common/util/Serializers/GsonImp.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/GsonImp.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/Serializers/GsonImp.java	(revision 83)
@@ -15,4 +15,10 @@
 import com.google.gson.JsonParser;
 
+/**
+ * Json serialize implementation. It uses the Gson libraries.
+ * 
+ * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
+ * 
+ */
 public class GsonImp implements ISerializer {
 	private final Gson gson = new Gson();
Index: trunk/src/main/java/omq/common/util/Serializers/ISerializer.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/ISerializer.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/Serializers/ISerializer.java	(revision 83)
@@ -7,4 +7,6 @@
 
 /**
+ * An ISerializer object can serialize any kind of objects and deserialize
+ * Requests and Responses.
  * 
  * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
@@ -12,8 +14,39 @@
  */
 public interface ISerializer {
+	/**
+	 * Serialize
+	 * 
+	 * @param obj
+	 *            - object to serialize
+	 * @return objectSerialized
+	 * @throws SerializerException
+	 *             - If the serialization failed
+	 */
 	public byte[] serialize(Object obj) throws SerializerException;
 
+	/**
+	 * Deserialize a Request
+	 * 
+	 * @param bytes
+	 *            - serialized request
+	 * @param obj
+	 *            - remoteObject which is receiving requests
+	 * @return request
+	 * @throws SerializerException
+	 *             - If the serialization failed
+	 */
 	public Request deserializeRequest(byte[] bytes, RemoteObject obj) throws SerializerException;
 
+	/**
+	 * Deserialize a Response
+	 * 
+	 * @param bytes
+	 *            serialized response
+	 * @param type
+	 *            - return type expected
+	 * @return response
+	 * @throws SerializerException
+	 *             - If the serialization failed
+	 */
 	public Response deserializeResponse(byte[] bytes, Class<?> type) throws SerializerException;
 }
Index: trunk/src/main/java/omq/common/util/Serializers/JavaImp.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/JavaImp.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/Serializers/JavaImp.java	(revision 83)
@@ -12,4 +12,5 @@
 
 /**
+ * Java serialize implementation. It uses the default java serialization.
  * 
  * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
Index: trunk/src/main/java/omq/common/util/Serializers/KryoImp.java
===================================================================
--- trunk/src/main/java/omq/common/util/Serializers/KryoImp.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/Serializers/KryoImp.java	(revision 83)
@@ -13,4 +13,5 @@
 
 /**
+ * Kryo serializerimplementation. It uses the Kryo libraries.
  * 
  * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
Index: trunk/src/main/java/omq/common/util/Zipper.java
===================================================================
--- trunk/src/main/java/omq/common/util/Zipper.java	(revision 77)
+++ trunk/src/main/java/omq/common/util/Zipper.java	(revision 83)
@@ -7,4 +7,11 @@
 import java.util.zip.GZIPOutputStream;
 
+/**
+ * This class enables the compression of the information sent through the
+ * rabbitmq server.
+ * 
+ * @author Sergi Toda <sergi.toda@estudiants.urv.cat>
+ * 
+ */
 public class Zipper {
 
@@ -16,12 +23,12 @@
 			zos = new GZIPOutputStream(baos);
 			zos.write(b);
-		} finally{
-			if(zos != null){
+		} finally {
+			if (zos != null) {
 				zos.close();
 			}
-			
+
 			baos.close();
 		}
-		
+
 		return baos.toByteArray();
 	}
@@ -34,5 +41,5 @@
 		try {
 			zis = new GZIPInputStream(bais);
-			
+
 			byte[] tmpBuffer = new byte[256];
 			int n;
@@ -40,14 +47,14 @@
 				baos.write(tmpBuffer, 0, n);
 			}
-		} finally {		
-			if(zis != null){
+		} finally {
+			if (zis != null) {
 				zis.close();
 			}
-			
+
 			bais.close();
 			baos.close();
-		}		
-		
+		}
+
 		return baos.toByteArray();
-	}	
+	}
 }